Attribute VB_Name = "graphic"

Option Explicit
'############################################
'############################################
Public Sub ShowGraphicScreen()
'############################################
'############################################
    frmGraph.frameGraphicScanBtns.Visible = True
    frmGraph.frameTextScan.Visible = False
    frmGraph.btnShowGraphicOrTextScan.Caption = "Text Scrn"
    frmGraph.Frame1.Visible = True
    bChanCnt = 9   'Load this from .ini file at startup
    frmGraphTextVolts.Visible = True
    
    If M_201.tScan = 2 Then
        frmCalVlts.Visible = True
        frmCalVlts.Left = frmGraphTextVolts.Left
        frmCalVlts.Top = frmGraphTextVolts.Top + frmGraphTextVolts.Height
        frmCalVlts.txtFocus.SetFocus
    Else
        frmCalVlts.Visible = False
    End If

    frmGraph.Line6.Visible = True

    'TIME - Taken from form loading. This needs
    '   modified to use runtime values where appropriate.
    Dim bIndex As Byte

    LXPixTotal = (frmGraph.Width - iMargin)  'ScaleWidth          'number of pixels on horizontal axis use these two to place the display
    LXPixTotal = LXPixTotal - (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)  'number of available pixels on horizontal axis
    
    
    'LXPixTotal = LXPixTotal - 50 '9-27-13b
    
    HorizDivMainCalc

    dblLastX = (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)
        Dim dblMax As Double
        dblMax = dblMaxFullScale
        Dim dblMin As Double
        dblMin = dblMinFullScale
        
        frmGraph.txtPosFullScale = dblMax
        fRetVal = txtPosFullScale_KeyUp_DoIt(13, 0)
        frmGraph.txtNegFullScale = dblMin
        fRetVal = txtNegFullScale_KeyUp_DoIt(13, 0)

    dblZoomFactor = 1
    dblPercentFullScale = 100
    DrawScreen
    Dim bRetVal, bEnable, bSetupAllChansAndSubs As Byte: bEnable = 1: bSetupAllChansAndSubs = 0
    bRetVal = frmGraph.SelectScanChanButtons(bEnable, bSetupAllChansAndSubs, 0)
    
End Sub
'############################################
'############################################
Public Function txtPosFullScale_KeyUp_DoIt(KeyCode As Integer, Shift As Integer)
'############################################
'############################################
    If KeyCode = 189 Then                'got a minus
         bGraphFullScalePosIsNeg = 1: GoTo EXIT1
    End If
    If KeyCode = 187 Then                'got a plus
         bGraphFullScalePosIsNeg = 0: GoTo EXIT1
    End If
    
    If KeyCode = 13 Then                'got ENTER key
        If frmGraph.txtPosFullScale.Text = "" Then GoTo EXIT1
        If frmGraph.txtPosFullScale.Text = "." Then GoTo ExitErr
        On Error GoTo ExitErr
        HandlePostFullscaleUpdate
        GoTo EXIT1
    End If
    
    If KeyCode = 8 Then GoTo ExitErr
    If KeyCode > 57 Or KeyCode < 46 Then GoTo ExitErr
    GoTo EXIT1
    
ExitErr:
    If KeyCode = 190 Then GoTo EXIT1        'VB sees period (in text double) as 190
    'MsgBox "Enter numeric values only  " & KeyCode, 0
    frmGraph.txtPosFullScale.Text = ""
    On Error GoTo 0
    
EXIT1:
End Function
'############################################
'############################################
Public Function txtNegFullScale_KeyUp_DoIt(KeyCode As Integer, Shift As Integer)
'############################################
'############################################
    If KeyCode = 189 Then                'got a minus
         bGraphFullScaleNegIsPos = 1: GoTo EXIT1
    End If
    If KeyCode = 187 Then                'got a plus
         bGraphFullScaleNegIsPos = 0: GoTo EXIT1
    End If

    If KeyCode = 13 Then                'got ENTER key
        If frmGraph.txtNegFullScale.Text = "" Then GoTo EXIT1
        If frmGraph.txtNegFullScale.Text = "." Then GoTo ExitErr
        On Error GoTo ExitErr
        
        If frmGraph.txtNegFullScale.Text = "0" Then frmGraph.txtNegFullScale.Text = ".00001"
    
        HandleNegFullscaleUpdate
        GoTo EXIT1
    End If
    
    If KeyCode = 8 Then GoTo ExitErr
    If KeyCode > 57 Or KeyCode < 46 Then GoTo ExitErr
    GoTo EXIT1
    
ExitErr:
    If KeyCode = 190 Then GoTo EXIT1        'VB sees period (in text double) as 190
    'MsgBox "Enter numeric values only  " & KeyCode, 0
    frmGraph.txtNegFullScale.Text = ""
    On Error GoTo 0
    
EXIT1:
End Function
'############################################
'############################################
Public Sub UpdateGraphDisplay()
'############################################
'############################################
    If dblYIndex > 5# Then
'3-11-05b        frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.0")
    Else
'3-11-05b        frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.00000")
    End If
    
    frmGraph.txtPosFullScale.Text = Format$(dblYFS, "#.00000")
    frmGraph.txtNegFullScale.Text = Format$(dblYFS - dblYRange, "#.00000")
End Sub
'############################################
'############################################
Public Sub UpdateZoomIndex()
'############################################
'############################################
    Select Case dblZoomFactor
       Case 1: dblYIndex = 1#: Case 2: dblYIndex = 0.5: Case 4: dblYIndex = 0.2: Case 8: dblYIndex = 0.1: Case 16: dblYIndex = 0.05: Case 32: dblYIndex = 0.02: Case 64: dblYIndex = 0.01: Case 128: dblYIndex = 0.005: Case 256: dblYIndex = 0.002: Case 512: dblYIndex = 0.001: Case 1024: dblYIndex = 0.0005: Case 2048: dblYIndex = 0.0002: Case 4096: dblYIndex = 0.0001: Case 8192: dblYIndex = 0.00005: Case 16384: dblYIndex = 0.00005: Case 32768: dblYIndex = 0.00002: Case Else: dblYIndex = 0.001
    End Select
End Sub
'############################################
'############################################
Public Sub BtnUnzoom_Click_DoIt()
'############################################
'############################################
    If dblZoomFactor < 2 Then GoTo EXIT1

    dblYRange = dblYRange * 2
    If dblYRange > 10 Then dblYRange = 10
    If dblYRange = 0 Then dblYRange = 0.001
    
    dblZoomFactor = 10 / dblYRange

    dblPercentFullScale = dblPercentFullScale * 2
    UpdateGraphDisplay
EXIT1:
End Sub
'############################################
'############################################
Public Sub BtnZoom_Click_DoIt()
'############################################
'############################################
    If dblZoomFactor < 1 Then dblZoomFactor = 1
    If dblZoomFactor >= 32768 Then dblZoomFactor = 32768: GoTo EXIT1

    dblYRange = dblYRange / 2
    If dblYRange = 0 Then dblYRange = 0.001
    
    If dblYRange < 0.0003 Then dblYRange = 10 / 32768
    dblZoomFactor = 10 / dblYRange

    dblPercentFullScale = dblPercentFullScale / 2#
    UpdateGraphDisplay
EXIT1:
End Sub
'############################################
'############################################
Public Sub BtnClear_Click_DoIt()
'############################################
'############################################
    frmGraph.BackColor = &H1
    frmGraph.BackColor = &H0&
    DrawScreen
    Dots
End Sub
'############################################
'############################################
Sub InitGraph()
'############################################
'############################################
    LXPixTotal = (frmGraph.Width - iMargin)  'ScaleWidth          'number of pixels on horizontal axis use these two to place the display
    LXPixTotal = LXPixTotal - (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)  'number of available pixels on horizontal axis
    
    HorizDivMainCalc
    dblLastX = (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)
    
    VertDivMainCalc
    
    dblZoomFactor = 1
    dblPercentFullScale = 100
    
    DrawScreen
    
    If fAnyScanRunning = True Then
        dblZoomFactor = 1
    Else
    End If
    DoEvents
    fGraphIsDisplayed = True
    
EXIT1:

End Sub
'############################################
'############################################
Public Function DoPlotWrap(bMainChan As Byte, dblPixPerPoint_local As Double) As Byte
'############################################
'############################################
    Dim bIndex, bVoltArrayIndex As Byte
    Dim LRedVal As Long: Dim bRedVal As Byte: Dim LGreenVal As Long: Dim bGreenVal As Byte: Dim LBlueVal As Long: Dim bBlueVal As Byte
    Dim bSubChanIndex As Byte
    
    bVoltArrayIndex = 0
    
    
    If fClearGraphicScreenNow Then
        fClearGraphicScreenNow = False
        dblLastX = (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)
        
        '9-4-04
        dblScanCntTemp = (scanCnt - 1#) * M_201.scanInterval
         If dblScanCntTemp > 1 Then
            frmGraph.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
        End If
        
        BtnClear_Click_DoIt
    End If
    
    'TIM NOTE: None of the following used, since the call to "Dots()" below has been changed.
    '3-24-03 LDotCol = Int((dblX - (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)) / dblXIndexPix + 0.5) * dblXIndexPix + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)
'    LDotCol = Int((dblX - (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)) _
'        / dblXIndexPix) * dblXIndexPix + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)
    frmGraphTextVolts.lblGraphChan = frmGraph.comboMainChan.Text


    '#####################################
    'Erase Old Data ====================
    frmGraph.DrawWidth = 1
'12-8-15 original    frmGraph.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph.Height), RGB(0, 0, 0), BF


    'frmGraph.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph.Height), RGB(0, 0, 0), BF
    'frmGraph.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph.Height - 2800), RGB(80, 80, 80), BF
    'frmGraph.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph.Frame6.Height - 50), RGB(80, 80, 80), BF
    '12-9-15
    frmGraph.Line (dblLastX, 0)-Step(dblPixPerPoint_local + 60#, frmGraph.framePlotSpaceHeight.Height), RGB(0, 0, 0), BF

'test
'    frmGraph.DrawWidth = 100 'dblPixPerPoint_local
'    'frmGraph.Line (dblLastX + (dblPixPerPoint_local / 2), (frmGraph.Height - frmGraph.frameTextScan.Height) + 200)-(dblLastX + (dblPixPerPoint_local / 2), frmGraph.Height), RGB(80, 80, 80)
'    frmGraph.Line (dblLastX + (dblPixPerPoint_local / 2), (frmGraph.Height - frmGraph.frameTextScan.Height) + 200)-(dblLastX + (dblPixPerPoint_local / 2), frmGraph.Height), RGB(80, 80, 80)

    
    '===================================
    '#####################################


    '#####################################
    'draw vertical locating bar =========
'    frmGraph.Line (dblLastX + dblPixPerPoint_local + 20#, 0)-(dblLastX + dblPixPerPoint_local + 20#, frmGraph.Height), RGB(0, 164, 200)
    '===================================
    '#####################################

    '#####################################
    'Draw new dots if necessary ==========
    Dim XTemp As Integer
    
    For XTemp = ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) _
            + dblXIndexPix) To (LXPixTotal + (frmGraph.frameLeftGraphMarker.Left _
            + frmGraph.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
        LDotCol = Int(XTemp + 0.5)
        '11-2-06 If (LDotCol > dblLastX) And (LDotCol < (dblLastX + (dblPixPerPoint_local + 60#))) Then
        If (LDotCol > dblLastX) And (LDotCol < (dblLastX + (dblPixPerPoint_local + 20#))) Then
            Dots
        End If
    Next
    
DONE_DOT_CHK:
    
    '12-21-04b frmGraph.DrawWidth = 2
    frmGraph.DrawWidth = 1

    For bSubChanIndex = 0 To 15
        If dVoltageValid(bMainChan, bSubChanIndex) = 1 Then
            If dVoltage(bMainChan, bSubChanIndex) < 0 Then 'Just used to improve display of negative
                frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(Abs(dVoltage(bMainChan, bSubChanIndex))), "-#.000000")
            Else
                frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(dVoltage(bMainChan, bSubChanIndex)), " #.000000")
            End If

            bCurGraphSubChan_Global = bSubChanIndex

            iY = (dblYFS - dVoltage(bMainChan, bSubChanIndex)) * dblPixsPerVolt
            If iY >= LYPixTotal Then iY = LYPixTotal - 1

            If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
            If iY < 2 Then iY = 2

            LRedVal = lngScanChanColors(bSubChanIndex): bRedVal = LRedVal And &HFF
            LGreenVal = lngScanChanColors(bSubChanIndex): LGreenVal = LGreenVal \ 256: bGreenVal = LGreenVal And &HFF
            LBlueVal = lngScanChanColors(bSubChanIndex): LBlueVal = Int(LBlueVal \ 65536): bBlueVal = LBlueVal And &HFF

            If frmGraph.btnChans(bSubChanIndex).BackColor <> &H8000000F Then
            
            
'11-19-15 do this on only enabled channels
'If dPrevVoltages(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then dblGraphVoltsMax = dPrevVoltages(bMainChan, bSubChanIndex)
'If dPrevVoltages(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then dblGraphVoltsMin = dPrevVoltages(bMainChan, bSubChanIndex)
            
            
                frmGraph.Line (dblLastX, LLastY(bSubChanIndex))-(dblX, iY), RGB(bRedVal, bGreenVal, bBlueVal)
            End If
            
            LLastY(bSubChanIndex) = iY

        Else
            frmGraphTextVolts.txtGrTextVolts(bSubChanIndex).Text = "     ---"
        End If
    Next bSubChanIndex
    
    dblLastX = dblX
End Function
'############################################
'############################################
Public Function Plot(bMainChan As Byte)
'############################################
'############################################

    Dim bAutoScalePending As Byte:  bAutoScalePending = 0
    
    Dim bIndex, bSubChanIndex As Byte
    Dim LRedVal As Long: Dim bRedVal As Byte: Dim LGreenVal As Long: Dim bGreenVal As Byte: Dim LBlueVal As Long: Dim bBlueVal As Byte
    Dim dblVoltArraySave(6, 16) As Double
    Dim dblVoltArray_Local(6, 16) As Double
    Dim dVoltageNoOffset_Original(6, 16) As Double
    
    Dim bMainGraphChan As Byte
    
    
    '4-14-04 bMainGraphChan = frmGraph.comboMainChan.Text
    '4-14-04 If fIsEMFapp Then bMainGraphChan = bMainGraphChan - 1
    
    '4-14-04
    bMainGraphChan = bCurMainChan_Global
    
'frmGraph.Frame5.Visible = True
'frmGraph.Frame5.Caption = "  no wrap"
'frmGraph.l1.Caption = "bMainChan :     " & bMainChan
'frmGraph.l2.Caption = "bMainGraphChan : " & bMainGraphChan
'frmGraph.l3.Caption = "dblLastX :     " & Format$(Str(dblLastX), " #.00")
'frmGraph.l4.Caption = "dblX :     " & Format$(Str(dblX), " #.00")
'frmGraph.l5.Caption = "dblPixPerPoint_part1 :     " & Format$(Str(dblPixPerPoint_part1), " #.00")
    
    Dim dblTempVal As Double
    Dim dblYTemp As Double
    
    For bSubChanIndex = 0 To 15
        dVoltageNoOffset_Original(bMainChan, bSubChanIndex) = dVoltage(bMainChan, bSubChanIndex)
    Next bSubChanIndex
    
'9-25-13e
'If fGotClear Then BtnClear_Click_DoIt
    
    
    '4-8-04
    'TIM NOTE: I need to improve this, but it's better than nothing right now
    If fGraphicScreenClearPending = True Then
        BtnClear_Click_DoIt
        fGraphicScreenClearPending = False

        '9-4-04
        dblScanCntTemp = (scanCnt - 1#) * M_201.scanInterval
         If dblScanCntTemp > 1 Then
            frmGraph.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
        End If

        If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then bAutoScalePending = 1
    End If
    
    
    'if save-offset requested --- do it now ##########################
    '9-24-13 If fRecordOffsetsNow Then
    '9-25-13 If fRecordOffsetsNow Or fResetLocalOffsets Then
    If fRecordOffsetsNow Then
    
'9-25-13 WATCH
        '9-25-13 fRecordOffsetsNow = False
        
        '9-24-13 #####################
        'frmGraphTextVolts.btnUsingOffsets.Enabled = True
        '9-25-13 fResetLocalOffsets = False
        '#########################

        '9-25-13 BtnClear_Click_DoIt

        If bLocalAvg > 1 Then
            fVoltageAvgArraysNeedsInit_Pending = True
        End If
    End If
    'end of saving offset voltage ####################################
    
    If bMainGraphChan = bMainChan Then
        For bSubChanIndex = 0 To 15
            dblVoltArraySave(bMainChan, bSubChanIndex) = dVoltage(bMainChan, bSubChanIndex)
            dblVoltArray_Local(bMainChan, bSubChanIndex) = dVoltage(bMainChan, bSubChanIndex)
        Next
    End If
        
        
        
        
    If bMainGraphChan = bMainChan Then
        '#####################################
        'Do autoscale first pass =============
        '9-26-13c If (dblScanNum = 0) And ((dblLastX = (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width))) And (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then
'11-19-15 comment to match 30x
'testing commented/uncommented
        If (dblScanNum = 0) And ((dblLastX = (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width))) Then
            '4-12-04 AutoScale (bMainChan)

            '9-4-04
            dblScanCntTemp = (scanCnt - 1#) * M_201.scanInterval
            If dblScanCntTemp > 1 Then
                '9-25-13 frmGraph.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
                '9-26-13c frmGraph.txtGraphStartTime.Text = CInt(Format$(dblScanCntTemp, " ########"))
                frmGraph.txtGraphStartTime.Text = "0"
            End If

            '4-12-04 ##################
            bIndex = 0

            '9-26-13c just following line
            If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then
                For bSubChanIndex = 0 To 15
                    If (frmGraph.btnChans(bSubChanIndex).Enabled = True) And (frmGraph.btnChans(bSubChanIndex).BackColor <> &H8000000F) Then
                        dblAutoScaleVoltages(bIndex) = dVoltage(bMainChan, bSubChanIndex)
                        
'If bAutoScale Then '11-23-15 just this line
                        
                        
                        
'11-19-15
If dVoltage(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then
    dblGraphVoltsMax = dVoltage(bMainChan, bSubChanIndex)
End If
If dVoltage(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then
    dblGraphVoltsMin = dVoltage(bMainChan, bSubChanIndex)
End If
                        
                        
'End If '11-23-15 just this line
                        
                        
                        
'11-23-15 START ##
'If bAutoScale Then
'    dblGraphVoltsMin = 5#
'    dblGraphVoltsMax = -5#
'End If
'11-23-15 END ####
                        
'11-23-15f comment code below to remove temp max/min boxes
''11-23-15
'If dblGraphVoltsMax < 0 Then 'Just used to improve display of negative
'    frmGraph.Text24 = Format$(str(Abs(dblGraphVoltsMax)), "-#.000000")
'Else
'    frmGraph.Text24 = Format$(str(Abs(dblGraphVoltsMax)), " #.000000")
'End If
'
'If dblGraphVoltsMin < 0 Then 'Just used to improve display of negative
'    frmGraph.Text26 = Format$(str(Abs(dblGraphVoltsMin)), "-#.000000")
'Else
'    frmGraph.Text26 = Format$(str(Abs(dblGraphVoltsMin)), " #.000000")
'End If
                        
                        
                        bIndex = bIndex + 1
                    End If
                Next bSubChanIndex
                AutoScale (bIndex)
            End If '9-26-13c
            '4-12-04 ##################


            For bSubChanIndex = 0 To 15
                dPrevVoltages(bMainChan, bSubChanIndex) = dVoltage(bMainChan, bSubChanIndex)
            Next bSubChanIndex
            dblLastX = frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width
            For bSubChanIndex = 0 To 15
                dblYTemp = (dblYFS - dblVoltArray_Local(bMainChan, bSubChanIndex)) * dblPixsPerVolt
                If dblYTemp >= LYPixTotal Then dblYTemp = (LYPixTotal * 1#) - 1#
                iY = Int(dblYTemp)
                If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
                If iY < 2 Then iY = 2
                LLastY(bSubChanIndex) = iY
            Next
            '11-23-15d dblScanNum = dblScanNum + 1

            scanCnt = 0 '9-26-13c

            BtnClear_Click_DoIt

            GoTo EXIT_SUB
        End If

        '11-23-15d dblScanNum = dblScanNum + 1
        '===================================
        '#####################################
    End If
    
    Dim dblWrapPercent, dblPixPerPoint_part1, dblPixPerPoint_part2 As Double
    Dim fGotWrap As Byte: fGotWrap = 0
    
    '9-25-13d
    If fGotClear Then
        fGotWrap = True
        fGotClear = False
        
'9-25-13e
'If fGotWrap Then BtnClear_Click_DoIt
'If fGotClear Then BtnClear_Click_DoIt
        
    End If
    
    dblPixPerPoint_part1 = dblPixPerDP
    
    '9-26-13e
    If scanCnt = 1 Then fClearGraphicScreenNow = 0
    
    If bMainGraphChan = bMainChan Then
        '11-24-03 NEW ##########################
        If fClearGraphicScreenNow Then
            fClearGraphicScreenNow = False
            dblLastX = frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width
            BtnClear_Click_DoIt
            If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then bAutoScalePending = 1

            '9-4-04
            dblScanCntTemp = (scanCnt - 1#) * M_201.scanInterval
            If dblScanCntTemp > 1 Then
                frmGraph.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
            End If
        End If
        '#######################################

        dblX = dblLastX + dblPixPerDP
    End If
    
    
'frmGraph.Frame5.Visible = True
'frmGraph.Frame5.Caption = "  no wrap"
'frmGraph.l1.Caption = "(frmGraph.Width -  iMargin) :     " & Format$(Str((frmGraph.Width -  iMargin)), " #.00")
'frmGraph.l2.Caption = "dblActualGraphRightEdge : " & Format$(Str(dblActualGraphRightEdge), " #.00")
'frmGraph.l3.Caption = "dblLastX :     " & Format$(Str(dblLastX), " #.00")
'frmGraph.l4.Caption = "dblX :     " & Format$(Str(dblX), " #.00")
'frmGraph.l5.Caption = "dblPixPerPoint_part1 :     " & Format$(Str(dblPixPerPoint_part1), " #.00")
    
    
    If bMainGraphChan <> bMainChan Then
        Exit Function
    End If
    
    '9-26-13e
'    If scanCnt = 1 Then bAutoScalePending = 0
    
    If (bAutoScalePending = 0) Then
        If dblX >= dblActualGraphRightEdge Then

            fGotWrap = 1
            dblPixPerPoint_part2 = dblX - dblActualGraphRightEdge
            dblPixPerPoint_part1 = dblPixPerDP - dblPixPerPoint_part2
            dblWrapPercent = dblPixPerPoint_part1 / dblPixPerDP
            For bSubChanIndex = 0 To 15
                If (dblWrapPercent * (dVoltage(bMainChan, bSubChanIndex) - dPrevVoltages(bMainChan, bSubChanIndex))) < dPrevVoltages(bMainChan, bSubChanIndex) Then
                    dblVoltArray_Local(bMainChan, bSubChanIndex) = dPrevVoltages(bMainChan, bSubChanIndex) + (dblWrapPercent * (dVoltage(bMainChan, bSubChanIndex) - dPrevVoltages(bMainChan, bSubChanIndex)))
                Else
                    dblVoltArray_Local(bMainChan, bSubChanIndex) = (dblWrapPercent * (dVoltage(bMainChan, bSubChanIndex) - dPrevVoltages(bMainChan, bSubChanIndex)) + dPrevVoltages(bMainChan, bSubChanIndex))
                End If
            Next bSubChanIndex
        End If
    Else
        'If scanCnt = 1 Then GoTo skipit '9-26-13e
        bAutoScalePending = 0
        '4-12-04 AutoScale (bMainChan)

        '4-12-04 ##################
        bIndex = 0
        For bSubChanIndex = 0 To 15
            If (frmGraph.btnChans(bSubChanIndex).Enabled = True) And (frmGraph.btnChans(bSubChanIndex).BackColor <> &H8000000F) Then
                dblAutoScaleVoltages(bIndex) = dVoltage(bMainChan, bSubChanIndex)
                bIndex = bIndex + 1
            End If
        Next bSubChanIndex
        AutoScale (bIndex)
        '4-12-04 ##################

        For bSubChanIndex = 0 To 15
            dblYTemp = (dblYFS - dblVoltArray_Local(bMainChan, bSubChanIndex)) * dblPixsPerVolt
            If dblYTemp >= LYPixTotal Then dblYTemp = (LYPixTotal * 1#) - 1#
            iY = Int(dblYTemp)
            If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
            If iY < 2 Then iY = 2
            LLastY(bSubChanIndex) = iY
        Next

        BtnClear_Click_DoIt
        dblLastX = frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width
'9-26-13d        GoTo EXIT_SUB
'skipit: '9-26-13e
    End If
        
    frmGraphTextVolts.lblGraphChan = frmGraph.comboMainChan.Text

    Dim intXLast As Long
    Dim intXNow As Long
    '5-10-05 intXLast = Int(dblLastX)
    '5-10-05 intXNow = Fix(dblX)
    
    '5-10-05
    intXLast = Int(dblLastX)
    intXNow = Int(dblX)
    
    'do not do the following or the x line will never move. The lines above will round the double
    'down each time for the current drawing, but the saved values are saved as doubles and will grow
    'as per the rate/per/screen which will eventually increase the values of the integers.
    'dblLastX = intXLast
    'dblX = intXNow
    

    '#####################################
    'Erase Old Data ====================
    '5-10-05 commented temporarily for testing
    frmGraph.DrawWidth = 1
    If intXNow > intXLast Then
       '5-10-05 frmGraph.Line (intXLast + Screen.TwipsPerPixelX, 0)-(intXNow + Screen.TwipsPerPixelX + 10, frmGraph.Height), RGB(0, 0, 0), BF
       'frmGraph.Line (intXLast + Screen.TwipsPerPixelX, 0)-(intXNow + Screen.TwipsPerPixelX + 10, frmGraph.frameTextScan.Height), RGB(0, 0, 0), BF
       frmGraph.Line (intXLast + Screen.TwipsPerPixelX, 0)-(intXNow + Screen.TwipsPerPixelX + 10, LYPixTotal - (1 * Screen.TwipsPerPixelY)), RGB(0, 0, 0), BF
    End If
    '===================================
    '#####################################


    '#####################################
    'draw vertical locating bar =========
    'TIM NOTE: both of the following do the exact same thing
    'frmGraph.Line (dblLastX + dblPixPerPoint_part1 + 20#, 0)-(dblLastX + dblPixPerPoint_part1 + 20#, frmGraph.Height), RGB(0, 164, 200)
    '    frmGraph.Line (dblLastX + dblPixPerPoint_part1 + 20#, 0)-Step(1, frmGraph.Height), RGB(0, 164, 200), BF
    '===================================
    '#####################################


    '#####################################
    'Draw new dots if necessary ==========
    Dim XTemp As Integer
    '5-10-05 commented temporarily for testing
'    For XTemp = ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) + dblXIndexPix) _
'            To (LXPixTotal + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
'        LDotCol = Int(XTemp + 0.5)
'        If (LDotCol > dblLastX) And (LDotCol < (dblLastX + (dblPixPerPoint_part1 + 60#))) Then
'            Dots
'         End If
'    Next

    '5-10-05 replace the doubles with the integers for the last-X
    For XTemp = ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) + dblXIndexPix) _
            To (LXPixTotal + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
        LDotCol = Int(XTemp + 0.5)
        If (LDotCol > intXLast) And (LDotCol < (intXLast + (dblPixPerPoint_part1 + 60#))) Then
            Dots
         End If
    Next
    '===================================
    '#####################################
    
    'intXLast
    'intXNow
    
    
DONE_DOT_CHK:
    '=====================================
    '#####################################
    '12-21-04b frmGraph.DrawWidth = 2
    frmGraph.DrawWidth = 1
    

    For bSubChanIndex = 0 To 15
        If dVoltageValid(bMainChan, bSubChanIndex) = 1 Then
            If dVoltage(bMainChan, bSubChanIndex) < 0 Then 'Just used to improve display of negative
                frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(Abs(dblVoltArray_Local(bMainChan, bSubChanIndex))), "-#.000000")
            Else
                frmGraphTextVolts.txtGrTextVolts(bSubChanIndex) = Format$(str(dblVoltArray_Local(bMainChan, bSubChanIndex)), " #.000000")
            End If
            dPrevVoltages(bMainChan, bSubChanIndex) = dblVoltArray_Local(bMainChan, bSubChanIndex)

            bCurGraphSubChan_Global = bSubChanIndex

            '3-15-05 iY = (dblYFS - dVoltage(bMainChan, bSubChanIndex)) * dblPixsPerVolt
            iY = ((dblYFS - dVoltage(bMainChan, bSubChanIndex)) * dblPixsPerVolt) - 1
            
            '5-11-05 If iY >= LYPixTotal Then iY = LYPixTotal - 1
            If iY >= LYPixTotal Then iY = LYPixTotal - (1 * Screen.TwipsPerPixelY)

            If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
            If iY < 2 Then iY = 2

            LRedVal = lngScanChanColors(bSubChanIndex): bRedVal = LRedVal And &HFF
            LGreenVal = lngScanChanColors(bSubChanIndex): LGreenVal = LGreenVal \ 256: bGreenVal = LGreenVal And &HFF
            LBlueVal = lngScanChanColors(bSubChanIndex): LBlueVal = Int(LBlueVal \ 65536): bBlueVal = LBlueVal And &HFF

            If frmGraph.btnChans(bSubChanIndex).BackColor <> &H8000000F Then
                '3-15-05 frmGraph.Line ((Int(dblLastX) - 10), LLastY(bSubChanIndex))-(dblX, iY), RGB(bRedVal, bGreenVal, bBlueVal)
                '3-16-05 frmGraph.Line (Int(dblLastX), LLastY(bSubChanIndex))-(dblX, iY), RGB(bRedVal, bGreenVal, bBlueVal)
                'frmGraph.Line (Int(dblLastX), Int(LLastY(bSubChanIndex)))-(Int(dblX), Int(iY)), RGB(bRedVal, bGreenVal, bBlueVal)
                'frmGraph.Line (dblLastX, LLastY(bSubChanIndex))-(dblX, iY), RGB(bRedVal, bGreenVal, bBlueVal)

'11-19-15 do this on only enabled channels
If dVoltage(bMainChan, bSubChanIndex) > dblGraphVoltsMax Then
    dblGraphVoltsMax = dVoltage(bMainChan, bSubChanIndex)
End If
If dVoltage(bMainChan, bSubChanIndex) < dblGraphVoltsMin Then
    dblGraphVoltsMin = dVoltage(bMainChan, bSubChanIndex)
End If
                
                
'11-23-15f comment code below to remove temp max/min boxes
''11-23-15
'If dblGraphVoltsMax < 0 Then 'Just used to improve display of negative
'    frmGraph.Text24 = Format$(str(Abs(dblGraphVoltsMax)), "-#.000000")
'Else
'    frmGraph.Text24 = Format$(str(Abs(dblGraphVoltsMax)), " #.000000")
'End If
'
'If dblGraphVoltsMin < 0 Then 'Just used to improve display of negative
'    frmGraph.Text26 = Format$(str(Abs(dblGraphVoltsMin)), "-#.000000")
'Else
'    frmGraph.Text26 = Format$(str(Abs(dblGraphVoltsMin)), " #.000000")
'End If
                
                frmGraph.Line (intXLast, LLastY(bSubChanIndex))-(intXNow, iY), RGB(bRedVal, bGreenVal, bBlueVal)
                
            End If
            LLastY(bSubChanIndex) = iY
        Else
            frmGraphTextVolts.txtGrTextVolts(bSubChanIndex).Text = "     ---"
        End If
        
        '9-26-13f moved from timer routine since it wasn't sincing with the plot drawing in single-chan mode
        '11-23-15d frmGraph.txtScanCnt.Text = Format$(dblScanCntTemp, " ########")
        frmGraph.txtScanBuff.Text = Format$(dblScanCntTemp, " ########")
        
    Next bSubChanIndex
    
    If fGotWrap Then
        '9-4-04
        dblScanCntTemp = (scanCnt - 1#) * M_201.scanInterval
         If dblScanCntTemp > 1 Then
            frmGraph.txtGraphStartTime.Text = Format$(dblScanCntTemp, " ########")
        End If

        For bSubChanIndex = 0 To 15
            dVoltage(bMainChan, bSubChanIndex) = dblVoltArray_Local(bMainChan, bSubChanIndex)
        Next bSubChanIndex

        If (frmGraphTextVolts.BtnAutoCenter.Caption = "Auto Scale  (on)") Then
            bIndex = 0
            For bSubChanIndex = 0 To 15
                If (frmGraph.btnChans(bSubChanIndex).Enabled = True) And (frmGraph.btnChans(bSubChanIndex).BackColor <> &H8000000F) Then
                    dblAutoScaleVoltages(bIndex) = dVoltage(bMainChan, bSubChanIndex)
                    bIndex = bIndex + 1
                End If
            Next bSubChanIndex
            AutoScale (bIndex)
        End If

        For bSubChanIndex = 0 To 15
            dblYTemp = (dblYFS - dblVoltArray_Local(bMainChan, bSubChanIndex)) * dblPixsPerVolt
            '12-8-15 If dblYTemp >= LYPixTotal Then dblYTemp = (LYPixTotal * 1#) - 1#
            If dblYTemp >= LYPixTotal Then dblYTemp = LYPixTotal - 1#
            iY = Int(dblYTemp)
            If LLastY(bSubChanIndex) = -10 Then LLastY(bSubChanIndex) = iY    'if first point, then same iY
            If iY < 2 Then iY = 2
            LLastY(bSubChanIndex) = iY
        Next

        dblX = dblPixPerPoint_part2 + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)
        dblLastX = (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width)

        For bSubChanIndex = 0 To 15
            dVoltage(bMainChan, bSubChanIndex) = dblVoltArraySave(bMainChan, bSubChanIndex)
        Next bSubChanIndex

        Dim bRetVal As Byte
        bRetVal = DoPlotWrap(bMainChan, dblPixPerPoint_part2)

    Else
        '3-16-05 dblLastX = dblX
        '5-10-05 dblLastX = intXNow
        '5-10-05 put this back
        dblLastX = dblX
    End If
EXIT_SUB: End Function
'############################################
'############################################
'See end of file for saved Plot Function
Public Sub AutoScale(ByVal bNumVoltages As Byte)
    Dim fRetVal As Boolean
    Dim bSubChanIndex, bVoltArrayIndex As Byte: bVoltArrayIndex = 0
    Dim bIndex As Byte

    If bNumVoltages = 0 Then Exit Sub
    
    For bIndex = 0 To (bNumVoltages - 1)
        dblMinMaxSubVolts(bIndex) = dblAutoScaleVoltages(bIndex)
    Next bIndex
    
    Dim dblMin As Double
    Dim dblMax As Double

    Dim dblVoltRange As Double
    Dim dblVoltCenter As Double

    fRetVal = GetMinMaxVolts(bNumVoltages, dblMin, dblMax)
    
    
    dblMax = dblGraphVoltsMax '11-19-15
    dblMin = dblGraphVoltsMin '11-19-15
    
    
    Dim dblMargin As Double
    dblMargin = (dblMax - dblMin) / 5# 'get 20% or range
    If dblMargin < 0.00005 Then
        dblMargin = 0.00005
    End If
    
    dblMax = dblMax + dblMargin
    dblMin = dblMin - dblMargin
    
    
    If dblMax > 5# Then dblMax = 5#
    If dblMin < -5# Then dblMin = -5#
    frmGraph.txtPosFullScale = dblMax
    fRetVal = txtPosFullScale_KeyUp_DoIt(13, 0)
    frmGraph.txtNegFullScale = dblMin
    fRetVal = txtNegFullScale_KeyUp_DoIt(13, 0)
    
    
    dblGraphVoltsMax = -5#  '11-19-15
    dblGraphVoltsMin = 5#   '11-19-15
    
    
    
End Sub
'############################################
'############################################
Public Sub Dots()
'############################################
'############################################
    Dim LIndex As Long
    Dim LDrawWidth As Long: LDrawWidth = frmGraph.DrawWidth
    
    Dim dblPosFullScale_TEMP, dblNegFullScale_TEMP, dblVoltsPerDivTemp As Double
    
    '3-11-05
    If (IsNumeric(frmGraph.txtPosFullScale.Text)) And (IsNumeric(frmGraph.txtNegFullScale.Text)) Then
        If (CDbl(frmGraph.txtPosFullScale.Text) <> 0) And (CDbl(frmGraph.txtNegFullScale.Text) <> 0) Then
            dblPosFullScale_TEMP = CDbl(frmGraph.txtPosFullScale.Text)
            dblNegFullScale_TEMP = CDbl(frmGraph.txtNegFullScale.Text)
            dblPosFullScale_TEMP = Abs(dblPosFullScale_TEMP)
            dblNegFullScale_TEMP = Abs(dblNegFullScale_TEMP)
           
            dblVoltsPerDivTemp = (dblPosFullScale_TEMP + dblNegFullScale_TEMP) / 10#
            '5-10-05 the old
'            If dblVoltsPerDivTemp > 5# Then
'                frmGraph.VoltsPerDiv.Text = Format$(dblVoltsPerDivTemp, "#.0")
'            Else
'                frmGraph.VoltsPerDiv.Text = Format$(dblVoltsPerDivTemp, "#.00000")
'            End If
            
            '5-10-05 the new
            If dblYIndex > 5# Then
                frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.0")
            Else
                frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.00000")
            End If
        End If
    End If
    
    sDotColorChange = 255:     frmGraph.DrawWidth = 1
    For LIndex = dblYIndexPix To (LYPixTotal - 1) Step dblYIndexPix
        If LDotCol > frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width + 20 Then
            frmGraph.Line (LDotCol, LIndex)-(LDotCol, LIndex + 15), RGB(80, sDotColorChange, 80)             'index vertical axis
        End If
    Next LIndex
    
    frmGraph.DrawWidth = LDrawWidth
    
End Sub
'############################################
'############################################
Public Sub DrawScreen()
'############################################
'############################################
    'Dim n As Integer
    Dim LIndex As Long
    Dim DC As Double
    
    Dim LDrawWidth As Long: LDrawWidth = frmGraph.DrawWidth
    frmGraph.DrawWidth = 1
    frmGraph.Line ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width), 0)-((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width), LYPixTotal), RGB(0, 0, 0)
    
    frmGraph.DrawWidth = 1
    For LIndex = 0 To (LYPixTotal - 1) Step Int(dblYIndexPix)
        'frmGraph.Line (frmGraph.frameLeftGraphMarker.Left, n - 1)-(frmGraph.frameLeftGraphMarker.Left, n + 1), RGB(255, 255, 0)
        frmGraph.Line ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width), LIndex - 1)-((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width), LIndex + 1), RGB(80, 255, 80)
    Next LIndex
    
    'frmGraph.Line (frmGraph.frameLeftGraphMarker.Left, LYPixTotal)-(LXPixTotal + frmGraph.frameLeftGraphMarker.Left, LYPixTotal), RGB(0, 0, 255)  'horizontal axis
    frmGraph.Line ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width), LYPixTotal)-(LXPixTotal + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width), LYPixTotal), RGB(80, 255, 80)  'horizontal axis
    
    For DC = ((frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) + dblXIndexPix) To (LXPixTotal + (frmGraph.frameLeftGraphMarker.Left + frmGraph.frameLeftGraphMarker.Width) + 1) Step dblXIndexPix
        LDotCol = Int(DC + 0.5)
        Dots
        frmGraph.Line (LDotCol - 1, LYPixTotal)-(LDotCol + 1, LYPixTotal), RGB(80, 255, 80)
    Next
    
    frmGraph.DrawWidth = LDrawWidth
    
End Sub
'############################################
'############################################
Public Sub HorizDivMainCalc()
'############################################
'############################################
    dblPixsPerSecond = (LXPixTotal - 1#) / dblXRange
    dblXIndexPix = dblXIndex * dblPixsPerSecond
    '3-16-05 dblPixPerDP = dblPixsPerSecond * M_201.scanInterval
    dblPixPerDP = dblPixsPerSecond * M_201.scanInterval
End Sub
'############################################
'############################################
Public Sub RecalcHorizDiv()
'############################################
'############################################
    ' Currently, this function only called when value is
    ' entered in sec/screen box
    Dim dblHorizDiv As Double
    dblHorizDiv = frmGraph.SecPerScrn.Text
    
    dblXRange = dblHorizDiv             'dblXRange time for one screen
    If dblXRange <= 0.1 Then
       dblXIndex = 0.01: GoTo CalcXPix 'dblXIndex index interval in seconds
    End If
    If dblXRange <= 2 Then
        dblXIndex = 0.1: GoTo CalcXPix
    End If
    
    dblXIndex = Int(dblXRange / 10 + 0.9)
        
CalcXPix:
    HorizDivMainCalc
    
    DrawScreen
End Sub
'############################################
'############################################
Public Sub VertDivMainCalc()
'############################################
'############################################
    Dim bIndex As Byte
    
    '12-8-15B LYPixTotal = frmGraph.ScaleHeight         'number of pixels on vertical axis
    '12-8-15B sVFrame = frmGraph.frameYbaseLocator.Height
    '12-8-15B LYPixTotal = LYPixTotal - sVFrame  'number of available pixels on vertical axis
    
    dblYRange = dblMaxFullScale                   'default voltage range, changed by zoom/unzoom

    Dim dblTemp As Double
    dblTemp = dblMinFullScale

    dblYIndex = dblYRange - dblTemp
    dblYFS = dblYIndex / 10                       'default Full Scale voltage, changed by autocenter

    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
    '5-11-05
    If dblYIndexPix < 1# Then dblYIndexPix = 1#

    
    If dblYIndex > 5# Then
'3-11-05b        frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.0")
    Else
'3-11-05b        frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.00000")
    End If
End Sub
'11-19-15 new to match 30x
'Public Sub VertDivMainCalc()
'    LYPixTotal = frmGraph.frameYbaseLocator.Top
'
'    dblYRange = dblMaxFullScale                     'default voltage range, changed by zoom/unzoom
'
'    Dim dblTemp As Double
'    dblTemp = dblMinFullScale
'
'    dblYIndex = dblYRange - dblTemp
'    dblYFS = dblYIndex / 10                       'default Full Scale voltage, changed by autocenter
'
'    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
'    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
'    If dblYIndexPix < 1# Then dblYIndexPix = 1#
'
'End Sub




'############################################
'############################################
Public Function SecPerScrn_KeyUp_DoIt(KeyCode As Integer, Shift As Integer)
'############################################
'############################################
    If KeyCode = 13 Then                'got ENTER key
        If frmGraph.SecPerScrn.Text = "" Then GoTo EXIT1
        If frmGraph.SecPerScrn.Text = "0" Then GoTo ExitErr
        If frmGraph.SecPerScrn.Text = "." Then GoTo ExitErr
        On Error GoTo ExitErr
        
        RecalcHorizDiv
        DrawScreen
        frmGraph.SecPerScrn.BackColor = &H0&
        frmGraph.SecPerScrn.ForeColor = &HFF00&
        frmGraph.txtGraphKeyEntry.SetFocus
        GoTo EXIT1
    End If
    
    If KeyCode = 8 Then GoTo ExitErr
    If KeyCode > 57 Or KeyCode < 46 Then GoTo ExitErr
    GoTo EXIT1
    
ExitErr:
    If KeyCode = 190 Then GoTo EXIT1        'VB sees period (in text double) as 190
    'MsgBox "Enter numeric values only  " & KeyCode, 0
    frmGraph.SecPerScrn.Text = ""
    On Error GoTo 0
    
EXIT1:
End Function
'############################################
'############################################
Public Function GetMinMaxVolts(ByVal bNumValidVoltages As Byte, ByRef dblMin As Double, ByRef dblMax As Double) As Boolean
'############################################
'############################################
    Dim bIndex, bIndex2 As Byte
    Dim minTEMP, maxTEMP As Double
    minTEMP = 5#
    maxTEMP = -5#
    
    frmGraph.Text8Neg = 0 & " " & minTEMP
    frmGraph.Text5Pos = 0 & " " & maxTEMP
    
    For bIndex = 0 To (bNumValidVoltages - 1)
        If dblMinMaxSubVolts(bIndex) < minTEMP Then
            minTEMP = dblMinMaxSubVolts(bIndex)
        End If
    Next bIndex
    
    For bIndex = 0 To (bNumValidVoltages - 1)
        If dblMinMaxSubVolts(bIndex) > (maxTEMP) Then
            maxTEMP = dblMinMaxSubVolts(bIndex)
        End If
    Next bIndex
    
    dblMin = minTEMP
    dblMax = maxTEMP
End Function
'############################################
'############################################
Public Sub HandlePostFullscaleUpdate()
'############################################
'############################################
    Dim dblMaxVolts As Double: dblMaxVolts = frmGraph.txtPosFullScale.Text
    Dim dblMinVolts As Double: dblMinVolts = frmGraph.txtNegFullScale.Text
    If dblMinVolts > dblMaxVolts Then dblMinVolts = dblMaxVolts - 0.0001
    
    frmGraph.txtNegFullScale.Text = Format$(dblMinVolts, "##.00000")
    frmGraph.txtPosFullScale.Text = Format$(dblMaxVolts, "##.00000")
    
    Dim dblVoltageRange As Double: dblVoltageRange = dblMaxVolts - dblMinVolts
    If dblVoltageRange < 0# Then
        dblVoltageRange = 0# - dblVoltageRange
    End If
    
    If dblVoltageRange < 0.00001 Then
        dblVoltageRange = 0.00001
    End If
    
    '12-8-15B LYPixTotal = frmGraph.ScaleHeight         'number of pixels on vertical axis
    '12-8-15B sVFrame = frmGraph.frameYbaseLocator.Height
    '12-8-15B LYPixTotal = LYPixTotal - sVFrame  'number of available pixels on vertical axis
    
    
    dblYRange = dblVoltageRange
    
    dblYIndex = dblMaxVolts / 10#
    dblYFS = dblMaxVolts                        'default Full Scale voltage, changed by autocenter
    If dblYRange = 0 Then dblYRange = 0.001
    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
    '5-11-05
    If dblYIndexPix < 1# Then dblYIndexPix = 1#
    
    If dblYIndex > 5# Then
'3-11-05c       frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.0")
    Else
'3-11-05c       frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.00000")
    End If
    'LLastY = -10                     'flag first time
    Dim bIndex As Byte
    For bIndex = 0 To 15
        LLastY(bIndex) = -10                     'flag first time
    Next bIndex
End Sub
'############################################
'############################################
Public Sub HandleNegFullscaleUpdate()
'############################################
'############################################
    Dim dblMaxVolts As Double: dblMaxVolts = frmGraph.txtPosFullScale.Text
    Dim dblMinVolts As Double: dblMinVolts = frmGraph.txtNegFullScale.Text
    If dblMinVolts > dblMaxVolts Then dblMaxVolts = dblMinVolts + 0.001
    
    frmGraph.txtPosFullScale.Text = Format$(dblMaxVolts, "##.00000"): frmGraph.txtNegFullScale.Text = Format$(dblMinVolts, "##.00000")
    
    Dim dblVoltageRange As Double: dblVoltageRange = dblMaxVolts - dblMinVolts
    If dblVoltageRange < 0# Then dblVoltageRange = 0# - dblVoltageRange
    
        
    Dim bIndex As Byte
    
    '12-8-15B LYPixTotal = frmGraph.ScaleHeight         'number of pixels on vertical axis
    '12-8-15B sVFrame = frmGraph.frameYbaseLocator.Height
    '12-8-15B LYPixTotal = LYPixTotal - sVFrame  'number of available pixels on vertical axis
    
    'dblYRange = dblMinVolts * 2                'default voltage range, changed by zoom/unzoom
    dblYRange = dblVoltageRange                 'default voltage range, changed by zoom/unzoom
    If dblYRange = 0 Then dblYRange = 0.001
    
    'dblYIndex = 2#                              'default index interval in volts
    dblYIndex = dblVoltageRange / 10#
    
    dblYFS = dblMaxVolts                        'default Full Scale voltage, changed by autocenter
    dblPixsPerVolt = (LYPixTotal - 1) / dblYRange
    dblYIndexPix = dblYIndex * dblPixsPerVolt    'pixels per index tick
    '5-11-05
    If dblYIndexPix < 1# Then dblYIndexPix = 1#
    
    If dblYIndex > 5# Then
'3-11-05c        frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.0")
    Else
'3-11-05c        frmGraph.VoltsPerDiv.Text = Format$(dblYIndex, "#.00000")
    End If
    
    'LLastY = -10                     'flag first time
    For bIndex = 0 To 15
        LLastY(bIndex) = -10                     'flag first time
    Next bIndex
    
End Sub









'Line (500, 500)Step(1000, 1000), RGB(100, 100, 100), BF

'===============================================
'graphic box example ===========================
'Dim StartFromLeft As Long
'StartFromLeft = 2000
'Dim StartFromTop As Long
'StartFromTop = 1000
'Dim GoDown As Long
'GoDown = 5000
'Dim GoRight As Long
'GoRight = 1000
'frmGraph.Line (StartFromLeft, StartFromTop)-Step(GoRight, GoDown), RGB(110, 110, 110), B
'example ===========================
'===================================

